/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef DIALOGMANAGER_H
#define DIALOGMANAGER_H

#include "About.h"
#include "Preferences.h"
#include "vocab.h"

#include <QStack>

class DialogManager : public QObject
{
    Q_OBJECT
public:
    DialogManager(QWidget *);
    ~DialogManager();

public slots:
    void showAbout();
    void showPreferences();
    virtual void closeAllDialogs();

signals:
    void allDialogsClosed();

protected:
    QWidget * parentWidget() const;
    void showDialog(Dialog *);

    About       * about;
    Preferences * preferences;

private:
    void cleanup();

    QStack<Dialog *> openDialogs;

private slots:
    void dialogFinished();
};

#endif

